# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from gi.repository import Gtk
from d_viewer import ShowPoem
from d_tablabel import TabLabel
import d_config, d_customs

class SavedMarks(Gtk.Dialog):
    
    def ok_m(self,*a):
        (model, i) = self.tree_sav.get_selection().get_selected()
        self.destroy()
        n3 = model.get_value(i,2)
        if n3 == 0:
            id_poem = model.get_value(i,0)
            text = model.get_value(i,1)
            sr = ShowPoem(self.parent)
            sr.loading(id_poem, self.parent.theme.fontmp)
            self.parent.viewerpoem.append_page(sr,TabLabel(sr, text))
            self.parent.viewerpoem.set_current_page(-1)
            self.parent.viewerpoem.show_all()
            sr.search_half(text)
            self.parent.main_notebook.set_current_page(3)
            self.parent.poems_tgl .set_sensitive(True)
        elif n3 == 1:
            id_page = model.get_value(i,0)
            book = model.get_value(i,1)
            self.parent.main_notebook.set_current_page(10)
            self.parent.my_booksviewer.set_pos(book, id_page)
    
    def remove_iter(self, *a):
        (model, i) = self.tree_sav.get_selection().get_selected()
        id_poem = model.get_value(i,0)
        for a in self.list_marks:
            if a[0] == id_poem :
                s = self.list_marks.index(a)
                self.list_marks.pop(s)
                model.remove(i)
                marks = repr(self.list_marks)
                d_config.setv('marks', marks)
    
    def remove_iters(self, *a):
        d_config.setv('marks', '[]')
        self.list_marks = []
        self.store_sav.clear()
    
    def __init__(self, parent):
        self.parent = parent
        self.list_marks = eval(d_config.getv('marks'))
        Gtk.Dialog.__init__(self, parent=self.parent)
        self.set_icon_name("Dawawin")
        area = self.get_content_area()
        area.set_spacing(6)
        self.set_title('المواضع المحفوظة')
        self.set_default_size(350, 300)
        box = Gtk.Box(spacing=6,orientation=Gtk.Orientation.VERTICAL)
        self.store_sav = Gtk.ListStore(int, str, int, str)
        for a in self.list_marks:
            if a[2] == 0: 
                s = 'قصيدة@'
            elif a[2] == 1: 
                s = 'كتاب@'
            self.store_sav.append([a[0], a[1], a[2], s])
        self.tree_sav = d_customs.TreeClass()
        self.tree_sav.connect("row-activated", self.ok_m)
        column = Gtk.TreeViewColumn('######',Gtk.CellRendererText(),text = 3)
        self.tree_sav.append_column(column)
        column = Gtk.TreeViewColumn('اسم الموضع',Gtk.CellRendererText(),text = 1)
        self.tree_sav.append_column(column)
        column.set_expand(True)
        self.tree_sav.set_model(self.store_sav)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_sav)
        remove = Gtk.Button("حذف")
        remove.connect('clicked', self.remove_iter)
        hb = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(remove, False, False, 0)
        remove_all = Gtk.Button("مسح")
        remove_all.connect('clicked', self.remove_iters)
        hb.pack_start(remove_all, False, False, 0)
        clo = Gtk.Button("إغلاق")
        clo.connect('clicked',lambda *a: self.destroy())
        hb.pack_end(clo, False, False, 0)
        box.pack_start(scroll, True, True, 0)
        box.pack_start(hb, False, False, 0)
        area.pack_start(box, True, True, 0)
        self.show_all()