# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from os.path import join
import os, pickle
from gi.repository import Gtk
from d_search import ShowResult, ShowResultBooks
from d_tablabel import TabLabel
import d_config, d_customs

class SavedResult(Gtk.Dialog):
    
    def ok_m(self,*a):
        (model, i) = self.tree_sav.get_selection().get_selected()
        if i :
            naw3 = model.get_value(i,1)
            if naw3 == 'الكتب@':
                nm = model.get_value(i, 0)
                self.parent.main_notebook.set_current_page(10)
                sr = ShowResultBooks(self.parent)
                sr.progress.hide()
                for c in self.parent.my_booksviewer.vbox_search.get_children():
                    self.parent.my_booksviewer.vbox_search.remove(c)
                self.parent.my_booksviewer.vbox_search.pack_start(sr, False, False, 0)
                self.parent.my_booksviewer.vbox_side.hide()
                sr.text, store = pickle.load(open(join(d_customs.HOME_DIR, 'books', nm+".pkl"), 'rb'))
                sr.results_list = store
                sr.n_result.set_label("عدد النتائج : "+str(len(sr.results_list)))
                for a in store:
                    sr.store_results.append(a)
            else:
                nm = model.get_value(i, 0)
                self.parent.main_notebook.set_current_page(4)
                self.parent.search_result_item.set_sensitive(True)
                sr = ShowResult(self.parent)
                sr.progress.hide()
                self.parent.resultsearch.append_page(sr,TabLabel(sr, nm))
                self.parent.resultsearch.set_current_page(-1)
                sr.text, store = pickle.load(open(join(d_customs.HOME_DIR, 'poets', nm+".pkl"), 'rb'))
                sr.results_list = store
                sr.n_result.set_label("عدد النتائج : "+str(len(sr.results_list)))
                for a in store:
                    sr.results_store.append(a)
            self.destroy()
                
    def remove_iter(self, *a):
        (model, i) = self.tree_sav.get_selection().get_selected()
        if i :
            res_self = d_customs.sure(self, " هل ترغب في حذف النتيجة المحددة ؟")
            if res_self:
                nm = model.get_value(i,0)
                naw3 = model.get_value(i,1)
                if naw3 == 'الكتب@': d = 'books'
                else: d = 'poets'
                os.remove(join(d_customs.HOME_DIR, d, nm+'.pkl'))
                self.store_sav.remove(i)
                
    def remove_iters(self, *a):
        res_self = d_customs.sure(self, " هل ترغب في حذف جميع النتائج الموجودة ؟")
        if res_self:
            res_book = os.listdir(join(d_customs.HOME_DIR, 'books'))
            res_poem = os.listdir(join(d_customs.HOME_DIR, 'poets'))
            for a in res_book:
                os.remove(join(d_customs.HOME_DIR, 'books', a))
            for a in res_poem:
                os.remove(join(d_customs.HOME_DIR, 'poets', a))
            self.store_sav.clear()
    
    def __init__(self, parent):
        self.parent = parent
        self.list_marks = eval(d_config.getv('marks'))
        Gtk.Dialog.__init__(self, parent=self.parent)
        self.set_icon_name("Dawawin")
        area = self.get_content_area()
        area.set_spacing(6)
        self.set_title('نتائج البحوث المحفوظة')
        self.set_default_size(350, 300)
        box = Gtk.Box(spacing=6,orientation=Gtk.Orientation.VERTICAL)
        self.store_sav = Gtk.ListStore(str, str)
        res_book = os.listdir(join(d_customs.HOME_DIR, 'books'))
        res_poem = os.listdir(join(d_customs.HOME_DIR, 'poets'))
        self.store_sav.clear()
        for v in res_book:
            if '.pkl' in v:
                nm = v.replace('.pkl', '')
                self.store_sav.append([nm, 'الكتب@'])
        for v in res_poem:
            if '.pkl' in v:
                nm = v.replace('.pkl', '')
                self.store_sav.append([nm, 'القصائد@'])
        self.tree_sav = d_customs.TreeClass()
        self.tree_sav.connect("row-activated", self.ok_m)
        column = Gtk.TreeViewColumn('#####', Gtk.CellRendererText(),text = 1)
        self.tree_sav.append_column(column)
        column = Gtk.TreeViewColumn('اسم البحث', Gtk.CellRendererText(),text = 0)
        column.set_expand(True)
        self.tree_sav.append_column(column)
        self.tree_sav.set_model(self.store_sav)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_sav)
        remove = Gtk.Button("حذف")
        remove.connect('clicked', self.remove_iter)
        hb = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(remove, False, False, 0)
        remove_all = Gtk.Button("مسح")
        remove_all.connect('clicked', self.remove_iters)
        hb.pack_start(remove_all, False, False, 0)
        clo = Gtk.Button("إغلاق")
        clo.connect('clicked',lambda *a: self.destroy())
        hb.pack_end(clo, False, False, 0)
        box.pack_start(scroll, True, True, 0)
        box.pack_start(hb, False, False, 0)
        area.pack_start(box, True, True, 0)
        self.show_all()