# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from gi.repository import Gtk, Gdk
import d_config, d_customs

#a----------------------------------------------------------------------       


class MyTheme(object):
    
    def apply_preference(self, *a):
        self.fontall = d_config.getv('fontall')
        if d_config.getn('theme') == 5:
            self.fonttd = d_config.getv('fonttd')
            self.fonttp = d_config.getv('fonttp')
            self.fontmp = d_config.getv('fontmp')
            self.fontch = d_config.getv('fontch')
            self.fontan = d_config.getv('fontan')
            self.colortd = d_config.getv('colortd')
            self.colortp = d_config.getv('colortp')
            self.colormp = d_config.getv('colormp')
            self.colorch = d_config.getv('colorch')
            self.coloran = d_config.getv('coloran')
            self.colorb = d_config.getv('colorb')
            self.colorfs = d_config.getv('colorfs')
            self.colorbs = d_config.getv('colorbs')
            self.colorss = d_config.getv('colorss')
            self.colorbp = d_config.getv('colorbp')   
        elif d_config.getn('theme') == 2:
            self.fonttd = 'KacstOne 15'
            self.fonttp = 'KacstOne 15'
            self.fontmp = 'Simplified Naskh 22'
            self.fontch = 'Amiri 18'
            self.fontan = 'KacstOne 15'
            self.colortd = 'rgb(164,201,240)'
            self.colortp = 'rgb(32,74,135)'
            self.colormp = 'rgb(52,101,164)'
            self.colorch = 'rgb(52,101,164)'
            self.coloran = 'rgb(204,0,0)'
            self.colorb = 'rgb(243,243,243)'
            self.colorfs = 'rgb(255,255,255)'
            self.colorbs = 'rgb(114,159,207)'
            self.colorss = 'rgb(254,250,135)'
            self.colorbp = 'rgb(15,41,72)'
        elif d_config.getn('theme') == 3:
            self.fontall = 'KacstOne 12'
            self.fonttd = 'KacstOne 15'
            self.fonttp = 'KacstOne 15'
            self.fontmp = 'Simplified Naskh 22'
            self.fontch = 'Amiri 18'
            self.fontan = 'KacstOne 15'
            self.colortd = 'rgb(3,102,57)'
            self.colortp = 'rgb(150,10,10)'
            self.colormp = 'rgb(92,53,102)'
            self.colorch = 'rgb(92,53,102)'
            self.coloran = 'rgb(204,0,0)'
            self.colorb = 'rgb(255,225,225)'
            self.colorfs = 'rgb(255,255,255)'
            self.colorbs = 'rgb(249,124,124)'
            self.colorss = 'rgb(254,250,135)'
            self.colorbp = 'rgb(234,252,202)'
        elif d_config.getn('theme') == 4:
            self.fontall = 'KacstOne 12'
            self.fonttd = 'KacstOne 15'
            self.fonttp = 'KacstOne 15'
            self.fontmp = 'Simplified Naskh 22'
            self.fontch = 'Amiri 18'
            self.fontan = 'KacstOne 15'
            self.colortd = 'rgb(211,215,207)'
            self.colortp = 'rgb(211,215,207)'
            self.colormp = 'rgb(186,189,182)'
            self.colorch = 'rgb(186,189,182)'
            self.coloran = 'rgb(254,229,186)'
            self.colorb = 'rgb(46,52,54)'
            self.colorfs = 'rgb(46,52,54)'
            self.colorbs = 'rgb(186,189,182)'
            self.colorss = 'rgb(0,0,0)'
            self.colorbp = 'rgb(46,52,54)'
        else:
            self.fonttd = 'KacstOne 15'
            self.fonttp = 'KacstOne 15'
            self.fontmp = 'Simplified Naskh 22'
            self.fontch = 'Amiri 18'
            self.fontan = 'KacstOne 15'
            self.colortd = 'rgb(46,52,54)'
            self.colortp = 'rgb(85,87,83)'
            self.colormp = 'rgb(85,87,83)'
            self.colorch = 'rgb(85,87,83)'
            self.coloran = 'rgb(204,0,0)'
            self.colorb = 'rgb(253,253,215)'
            self.colorfs = 'rgb(255,255,255)'
            self.colorbs = 'rgb(85,87,83)'
            self.colorss = 'rgb(243,201,96)'
            self.colorbp = 'rgb(211,215,207)'
    
    def __init__(self):
        self.refresh()
        
    def refresh(self, *a):
        self.apply_preference()
        css_data = '''
            * {font: '''+self.fontall+''';
            -GtkPaned-handle-size: 3;
            }
            GtkIconView:selected,
            View-editable:selected,
            View:selected,
            MyView:selected,
            Treepoem:selected,
            Tree:selected  {
            background-color: '''+d_customs.rgb(self.colorbs)+''';
            background-image: none;
            color: '''+d_customs.rgb(self.colorfs)+''';
            }
            View-editable {
            background-color: '''+d_customs.rgb(self.colorb)+''';
            background-image: none;
            color: '''+d_customs.rgb(self.colorch)+''';
            font: Simplified Naskh 15;
            }
            View {
            background-color: '''+d_customs.rgb(self.colorb)+''';
            background-image: none;
            color: '''+d_customs.rgb(self.colorch)+''';
            font: '''+self.fontch+''';
            }
            Tree {
            background-color: '''+d_customs.rgb(self.colorbp)+''';
            background-image: none;
            color: '''+d_customs.rgb(self.colortd)+''';
            font: '''+self.fonttd+''';
            }
            Treepoem {
            background-color: '''+d_customs.rgb(self.colorb)+''';
            background-image: none;
            color: '''+d_customs.rgb(self.colortp)+''';
            font: '''+self.fonttp+''';
            }
            Myscroll, MyView, GtkIconView{
            color: '''+d_customs.rgb(self.colormp)+''';
            font: '''+self.fontmp+''';
            }
            Myscroll, MyView , GtkIconView{
            background-color: '''+d_customs.rgb(self.colorb)+'''
            } 
            '''
        css_default = '''
            * {font: '''+self.fontall+''';
            -GtkPaned-handle-size: 3;
            }
            '''    
        screen = Gdk.Screen.get_default()
        css_provider = Gtk.CssProvider()
        context = Gtk.StyleContext()
        #if d_config.getn('theme') == 0: css_provider.load_from_data(css_default.encode('utf8'))
        #else: css_provider.load_from_data(css_data.encode('utf8')+css_default.encode('utf8'))
        context.add_provider_for_screen(screen, css_provider,
                                         Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)
        
