# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from gi.repository import Gtk


class About(Gtk.AboutDialog):
    
    def __init__(self, parent):
        self.parent = parent
        Gtk.AboutDialog.__init__(self, parent = self.parent, wrap_license = True)
        self.set_program_name("برنامج دواوين العرب")
        self.set_version("0.7.0")
        self.set_logo_icon_name('dawawin')
        self.set_comments("""برنامج لقراءة وتخزين شعر العرب""")
        self.set_website("http://www.linuxac.org")
        self.set_website_label('برعاية مجتمع لينكس العربي')
        self.set_authors(['',
                           'أحمد رغدي (المبرمج الأساسي)',
                           'فيصل شامخ (برمجة قارئ الملفات الصوتية) ',
                           'أحمد شريف (تجميع المادة الشعرية)',
                           'البكري (أيقونة البرنامج)',
                           'برعاية مجتمع لينكس العربي',
                           ])
        self.set_license("""
        برنامج دواوين العرب برمجية حرة ؛
        بإمكانك إعادة توزيعه مع أو دون تعديله ،
        تحت شروط الرخصة "وقف" ، يوزّع برنامج دواوين العرب
        على أمل أن يكون مفيدًا لمن يستخدمه دون أدنى ضمان  ؛
        يمكنك أن تطلع على هذه الرخصة في صفحتها الموجودة
        على هذا الرابط
        http://waqf.ojuba.org/ 
        شرط إضافة القصائد والدواوين:
        يجب عدم إيداع قصائد الشعراء الذين تناولوا الذات الإلهية
        في شعرهم بأي نوع تنقص كمن يشبه الله برجل في البادية
        أو من يزعم أنه ذبح علي أيدي رجال ما مثل ما فعل الهالك نزار قباني
        فلعمري هذا الصنف من الشعراء لم يقدموا لأمتهم شعرا فصيحا بليغا 
        يستفيدون منه لغة ولا قدموا شعرا هادفا يستفاد منه القيم والأخلاق
        وإنما قدموا الإلحاد والعهر والخنا في ثوب من الركاكة والعي
        لذلك أنا أشترط على كل مستعمل للموسوعة ذلك وأبرأ إلى الله
        من كل من خالف هذا الأمر والله حسيب كل أحد.
        """)
        self.run()
        self.destroy()
