# -*- coding: utf-8 -*-

#a############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
#a############################################################################

from os.path import join
from gi.repository import Gtk, Pango
import d_tools, d_araby, d_customs
import re

# class صفحة إضافة القصيدة-------------------------------------
    
class AddPoem(Gtk.Box):
    
    def write_info(self, item):
        self.nasse_bfr.insert_at_cursor('= '+item.get_label()) 
    
    def populate_popup(self, view, menu):
        c3 = Gtk.SeparatorMenuItem()
        menu.prepend(c3)
        c3.show()
        f1 = Gtk.MenuItem('النوع')
        imenu = Gtk.Menu()
        f1.set_submenu(imenu)
        f1m1 = Gtk.MenuItem(' النوع : قريض')
        imenu.append(f1m1)
        f1m2 = Gtk.MenuItem(' النوع : أرجوزة')
        imenu.append(f1m2)
        f1m3 = Gtk.MenuItem(' النوع : مُوشحة')
        imenu.append(f1m3)
        f1m4 = Gtk.MenuItem(' النوع : رُباعيّة')
        imenu.append(f1m4)
        f1m5 = Gtk.MenuItem(' النوع : قصيدة نثر')
        imenu.append(f1m5)
        f1m6 = Gtk.MenuItem(' النوع : مخمّسة')
        imenu.append(f1m6)
        f1.show_all()

        f2 = Gtk.MenuItem('الغرض')
        imenu = Gtk.Menu()
        f2.set_submenu(imenu)
        f2m1 = Gtk.MenuItem(' الغرض : وصف')
        imenu.append(f2m1)
        f2m2 = Gtk.MenuItem(' الغرض : تشبيه')
        imenu.append(f2m2) 
        f2m3 = Gtk.MenuItem(' الغرض : فخر')
        imenu.append(f2m3) 
        f2m4 = Gtk.MenuItem(' الغرض : حماسة')
        imenu.append(f2m4) 
        f2m5 = Gtk.MenuItem(' الغرض : نسيب')
        imenu.append(f2m5)
        f2m6 = Gtk.MenuItem(' الغرض : شكوى')
        imenu.append(f2m6)
        f2m7 = Gtk.MenuItem(' الغرض : عتاب')
        imenu.append(f2m7)
        f2m8 = Gtk.MenuItem(' الغرض : اعتذار')
        imenu.append(f2m8)
        f2m9 = Gtk.MenuItem(' الغرض : هجاء')
        imenu.append(f2m9)
        f2m10 = Gtk.MenuItem(' الغرض : وعيد')
        imenu.append(f2m10)
        f2m11 = Gtk.MenuItem(' الغرض : رثاء')
        imenu.append(f2m11) 
        f2m12 = Gtk.MenuItem(' الغرض : مدح')
        imenu.append(f2m12)
        f2m13 = Gtk.MenuItem(' الغرض : اقتضاء')
        imenu.append(f2m13)
        f2m14 = Gtk.MenuItem(' الغرض : علمي')
        imenu.append(f2m14) 
        f2m15 = Gtk.MenuItem(' الغرض : دفاع')
        imenu.append(f2m15) 
        f2m16 = Gtk.MenuItem(' الغرض : مناجاة')
        imenu.append(f2m16) 
        f2m17 = Gtk.MenuItem(' الغرض : زهد')
        imenu.append(f2m17) 
        f2m18 = Gtk.MenuItem(' الغرض : ملحمة')
        imenu.append(f2m18) 
        f2m19 = Gtk.MenuItem(' الغرض : إلغاز')
        imenu.append(f2m19) 
        f2m20 = Gtk.MenuItem(' الغرض : تأريخ')
        imenu.append(f2m20) 
        f2m21 = Gtk.MenuItem(' الغرض : هزل')
        imenu.append(f2m21) 
        f2m22 = Gtk.MenuItem(' الغرض : حكمة')
        imenu.append(f2m22)
        f2m23 = Gtk.MenuItem(' الغرض : قصصي')
        imenu.append(f2m23) 
        f2m24 = Gtk.MenuItem(' الغرض : هِنات')
        imenu.append(f2m24)
        f2m25 = Gtk.MenuItem(' الغرض : خليط')
        imenu.append(f2m25)
        f2.show_all() 

        f3 = Gtk.MenuItem('القافية')
        imenu = Gtk.Menu()
        f3.set_submenu(imenu)
        f3m1 = Gtk.MenuItem(' القافية : مطلقة')
        imenu.append(f3m1) 
        f3m2 = Gtk.MenuItem(' القافية : مقيدة')
        imenu.append(f3m2)
        f3.show_all() 

        f4 = Gtk.MenuItem('الروي')
        imenu = Gtk.Menu()
        f4.set_submenu(imenu)
        f4m1 = Gtk.MenuItem(' الروي : ألف')
        imenu.append(f4m1)
        f4m2 = Gtk.MenuItem(' الروي : باء')
        imenu.append(f4m2) 
        f4m3 = Gtk.MenuItem(' الروي : تاء')
        imenu.append(f4m3) 
        f4m4 = Gtk.MenuItem(' الروي : تاء مربوطة')
        imenu.append(f4m4) 
        f4m5 = Gtk.MenuItem(' الروي : ثاء')
        imenu.append(f4m5)
        f4m6 = Gtk.MenuItem(' الروي : جيم')
        imenu.append(f4m6)
        f4m7 = Gtk.MenuItem(' الروي : حاء')
        imenu.append(f4m7)
        f4m8 = Gtk.MenuItem(' الروي : خاء')
        imenu.append(f4m8)
        f4m9 = Gtk.MenuItem(' الروي : دال')
        imenu.append(f4m9)
        f4m10 = Gtk.MenuItem(' الروي : ذال')
        imenu.append(f4m10)
        f4m11 = Gtk.MenuItem(' الروي : راء')
        imenu.append(f4m11) 
        f4m12 = Gtk.MenuItem(' الروي : زاي')
        imenu.append(f4m12)
        f4m13 = Gtk.MenuItem(' الروي : سين')
        imenu.append(f4m13)
        f4m14 = Gtk.MenuItem(' الروي : شين')
        imenu.append(f4m14) 
        f4m15 = Gtk.MenuItem(' الروي : صاد')
        imenu.append(f4m15) 
        f4m16 = Gtk.MenuItem(' الروي : ضاد')
        imenu.append(f4m16) 
        f4m17 = Gtk.MenuItem(' الروي : طاء')
        imenu.append(f4m17) 
        f4m18 = Gtk.MenuItem(' الروي : ظاء')
        imenu.append(f4m18) 
        f4m19 = Gtk.MenuItem(' الروي : عين')
        imenu.append(f4m19) 
        f4m20 = Gtk.MenuItem(' الروي : غين')
        imenu.append(f4m20) 
        f4m21 = Gtk.MenuItem(' الروي : فاء')
        imenu.append(f4m21) 
        f4m22 = Gtk.MenuItem(' الروي : قاف')
        imenu.append(f4m22)
        f4m23 = Gtk.MenuItem(' الروي : كاف')
        imenu.append(f4m23) 
        f4m24 = Gtk.MenuItem(' الروي : لام')
        imenu.append(f4m24)
        f4m25 = Gtk.MenuItem(' الروي : ميم')
        imenu.append(f4m25)
        f4m26 = Gtk.MenuItem(' الروي : نون' )
        imenu.append(f4m26) 
        f4m27 = Gtk.MenuItem(' الروي : هاء' )
        imenu.append(f4m27)
        f4m28 = Gtk.MenuItem(' الروي : واو' )
        imenu.append(f4m28)
        f4m29 = Gtk.MenuItem(' الروي : ياء' )
        imenu.append(f4m29) 
        f4m30 = Gtk.MenuItem(' الروي : همزة' )
        imenu.append(f4m30)
        f4.show_all()

        f5 = Gtk.MenuItem('البحر')
        imenu = Gtk.Menu()
        f5.set_submenu(imenu)
        f5m1 = Gtk.MenuItem(' البحر : الطَّوِيل')
        imenu.append(f5m1) 
        f5m2 = Gtk.MenuItem(' البحر : المَدِيد')
        imenu.append(f5m2) 
        f5m3 = Gtk.MenuItem(' البحر : البَسِيط')
        imenu.append(f5m3) 
        f5m4 = Gtk.MenuItem(' البحر : الوافِر')
        imenu.append(f5m4) 
        f5m5 = Gtk.MenuItem(' البحر : الكامِل')
        imenu.append(f5m5) 
        f5m6 = Gtk.MenuItem(' البحر : الهَزَج')
        imenu.append(f5m6) 
        f5m7 = Gtk.MenuItem(' البحر : الرَجَز')
        imenu.append(f5m7) 
        f5m8 = Gtk.MenuItem(' البحر : الرَّمَل')
        imenu.append(f5m8) 
        f5m9 = Gtk.MenuItem(' البحر : السَّريع')
        imenu.append(f5m9) 
        f5m10 = Gtk.MenuItem(' البحر : المُنْسَرِح')
        imenu.append(f5m10) 
        f5m11 = Gtk.MenuItem(' البحر : الخفيف')
        imenu.append(f5m11) 
        f5m12 = Gtk.MenuItem(' البحر : المضارع')
        imenu.append(f5m12) 
        f5m13 = Gtk.MenuItem(' البحر : المقتضب')
        imenu.append(f5m13) 
        f5m14 = Gtk.MenuItem(' البحر : المجتث')
        imenu.append(f5m14) 
        f5m15 = Gtk.MenuItem(' البحر : المتقارب')
        imenu.append(f5m15) 
        f5m16 = Gtk.MenuItem(' البحر : المتدارك')
        imenu.append(f5m16)
        f5.show_all() 
      
        menu.prepend(f2)
        menu.prepend(f3)
        menu.prepend(f4)
        menu.prepend(f5)
        menu.prepend(f1)
        
        if not self.all_poems.get_active():
            f2.hide()
            f3.hide()
            f4.hide()
            f5.hide()
            f1.hide()
            c3.hide()
        
        f1m1.connect("activate", self.write_info)
        f1m2.connect("activate", self.write_info)
        f1m3.connect("activate", self.write_info)
        f1m4.connect("activate", self.write_info)
        f1m5.connect("activate", self.write_info)
        f1m6.connect("activate", self.write_info)
        f2m1.connect("activate", self.write_info)
        f2m2.connect("activate", self.write_info)
        f2m3.connect("activate", self.write_info)
        f2m4.connect("activate", self.write_info)
        f2m5.connect("activate", self.write_info)
        f2m6.connect("activate", self.write_info)
        f2m7.connect("activate", self.write_info)
        f2m8.connect("activate", self.write_info)
        f2m9.connect("activate", self.write_info)
        f2m10.connect("activate", self.write_info)
        f2m11.connect("activate", self.write_info)
        f2m12.connect("activate", self.write_info)
        f2m13.connect("activate", self.write_info)
        f2m14.connect("activate", self.write_info)
        f2m15.connect("activate", self.write_info)
        f2m16.connect("activate", self.write_info)
        f2m17.connect("activate", self.write_info)
        f2m18.connect("activate", self.write_info)
        f2m19.connect("activate", self.write_info)
        f2m20.connect("activate", self.write_info)
        f2m21.connect("activate", self.write_info)
        f2m22.connect("activate", self.write_info)
        f2m23.connect("activate", self.write_info)
        f2m24.connect("activate", self.write_info)
        f3m1.connect("activate", self.write_info)
        f3m2.connect("activate", self.write_info)
        f4m1.connect("activate", self.write_info)
        f4m2.connect("activate", self.write_info)
        f4m3.connect("activate", self.write_info)
        f4m4.connect("activate", self.write_info)
        f4m5.connect("activate", self.write_info)
        f4m6.connect("activate", self.write_info)
        f4m7.connect("activate", self.write_info)
        f4m8.connect("activate", self.write_info)
        f4m9.connect("activate", self.write_info)
        f4m10.connect("activate", self.write_info)
        f4m11.connect("activate", self.write_info)
        f4m12.connect("activate", self.write_info)
        f4m13.connect("activate", self.write_info)
        f4m14.connect("activate", self.write_info)
        f4m15.connect("activate", self.write_info)
        f4m16.connect("activate", self.write_info)
        f4m17.connect("activate", self.write_info)
        f4m18.connect("activate", self.write_info)
        f4m19.connect("activate", self.write_info)
        f4m20.connect("activate", self.write_info)
        f4m21.connect("activate", self.write_info)
        f4m22.connect("activate", self.write_info)
        f4m23.connect("activate", self.write_info)
        f4m24.connect("activate", self.write_info)
        f4m25.connect("activate", self.write_info)
        f4m26.connect("activate", self.write_info)
        f4m27.connect("activate", self.write_info)
        f4m28.connect("activate", self.write_info)
        f4m29.connect("activate", self.write_info)
        f4m30.connect("activate", self.write_info)
        f5m1.connect("activate", self.write_info)
        f5m2.connect("activate", self.write_info)
        f5m3.connect("activate", self.write_info)
        f5m4.connect("activate", self.write_info)
        f5m5.connect("activate", self.write_info)
        f5m6.connect("activate", self.write_info)
        f5m7.connect("activate", self.write_info)
        f5m8.connect("activate", self.write_info)
        f5m9.connect("activate", self.write_info)
        f5m10.connect("activate", self.write_info)
        f5m11.connect("activate", self.write_info)
        f5m12.connect("activate", self.write_info)
        f5m13.connect("activate", self.write_info)
        f5m14.connect("activate", self.write_info)
        f5m15.connect("activate", self.write_info)
        f5m16.connect("activate", self.write_info)
    
    def search_on_page(self, text):
        return
    
    def is_poet(self, *a):
        if self.present.get_active():
            self.notebook_down.set_current_page(1)
        elif self.outsider.get_active():
            self.notebook_down.set_current_page(0)
        else:
            self.notebook_down.set_current_page(2)
    
    def add_poet(self, *a):
        if self.outsider.get_active():
            msg = d_customs.sure(self.parent, '''
            هل أنت متأكد من أن 
            قائل هذه الأبيات غير معروف ؟
            ''' )
            if msg == Gtk.ResponseType.NO:
                return 'none', False, False, False
            else:
                return 0, 0, 22, 9
        elif self.present.get_active():
            poet, sex, balad, age = self.parent.db.id_name_poet(self.poets.get_text())
            if poet == None:
                d_customs.erro(self.parent, 'ضع الاسم الصحيح للشاعر'); return
        elif self.nopresent.get_active():
            nm = self.nm_poet.get_text()
            lak = self.lak_poet.get_text()
            if nm == lak == '': d_customs.erro(self.parent, 'ضع أسما للشاعر'); return
            if nm == '': nm += lak
            elif lak == '': lak += nm
            age = d_customs.value_active(self.ages)
            if age == None : d_customs.erro(self.parent, 'حدد عصر الشاعر\nأو اجعله غير معروف'); return
            balad = d_customs.value_active(self.lands)
            if self.lands.get_sensitive():
                if balad == None : d_customs.erro(self.parent, 'حدد بلد الشاعر\nأو اجعله غير معروف'); return
            else: balad = 22
            sex = d_customs.value_active(self.sexs)
            if sex == None : d_customs.erro(self.parent, 'حدد جنس الشاعر'); return
            if self.death.get_active(): die = self.dh_poet.get_value()
            else: die = 0
            tarjama = self.tarjama_bfr.get_text(self.tarjama_bfr.get_start_iter(),
                                                self.tarjama_bfr.get_end_iter(), False)
            poet, sex, balad, age = self.parent.db.add_poet(nm, lak, tarjama, die, sex, balad, age)
        return poet, sex, balad, age
        
    def adding(self, *a):
        if self.all_poems.get_active():
            self.adding_muth()
        else:
            self.adding_one()
        
    def adding_muth(self, *a):
        text = d_tools.right_space(self.nasse_bfr.get_text(self.nasse_bfr.get_start_iter(),
                                                        self.nasse_bfr.get_end_iter(), False))
        if text == '': d_customs.erro(self.parent, 'ضع القصائد أولا'); return
        gharadh = 0
        baher = 0
        rawi = 0
        kafia = 0
        arodh = 0
        sabab = ""
        charh = ""
        poet, sex, balad, age = self.add_poet()
        if poet == 'none': return
        self.set_sensitive(False)
        list_poems = text.split('#')
        for poem_text in list_poems:
            if len(poem_text) < 10: continue
            while (Gtk.events_pending()): Gtk.main_iteration()
            name, poem, naw3, gharadh, baher, rawi, kafia = d_tools.name_poem(poem_text)
            poem = d_tools.right_space(poem)
            if len(poem) < 10: continue
            label = Gtk.Label()
            label.override_font(Pango.FontDescription('KacstOne 15'))
            if naw3 != 5:
                if d_tools.is_machtor(poem):
                    longer_half, n_abiat = d_tools.longer_half(poem, label, 1)
                else:
                    longer_half, n_abiat = d_tools.longer_half(poem, label, 0)
            else: 
                longer_half = 0
                n_abiat = len(poem.splitlines(1))
            self.parent.db.add_poem(name, poem, sabab, charh, poet, sex, balad, age, 
                                 n_abiat, baher, rawi, kafia, arodh, gharadh, naw3, longer_half)
        self.parent.dawawin_page.refresh_poets()
        self.parent.dawawin_page.search_cb()
        self.parent.organiz.refresh_poets()
        self.parent.organiz.search_cb()
        d_customs.info(self.parent, 'تم إضافة جميع القصائد بنجاح')
        self.set_sensitive(True); return
    
    def adding_one(self, *a):
        text = d_tools.right_space(self.nasse_bfr.get_text(self.nasse_bfr.get_start_iter(),
                                                        self.nasse_bfr.get_end_iter(), False))
        if text == '': d_customs.erro(self.parent, 'ضع القصيدة أولا'); return
        nam = self.name_poem.get_text()
        if nam == '' : d_customs.erro(self.parent, 'ضع اسما للقصيدة\nأو أول شطر منها'); return
        naw3 = d_customs.value_active(self.naw3)
        if naw3 == None : d_customs.erro(self.parent, 'حدد نوع القصيدة'); return
        if naw3 == 1:
            baher = d_customs.value_active(self.baher)
            if baher == None : d_customs.erro(self.parent, 'حدد بحر القصيدة'); return
            rawi = d_customs.value_active(self.rawi)
            if rawi == None : d_customs.erro(self.parent, 'حدد روي القصيدة'); return
            kafia = d_customs.value_active(self.kafia)
            if kafia == None : d_customs.erro(self.parent, 'حدد قافية القصيدة'); return
            arodh = d_customs.value_active(self.arodh)
            if arodh == None : d_customs.erro(self.parent, 'حدد عروض القصيدة'); return
        elif naw3 == 2:
            baher = d_customs.value_active(self.baher)
            if baher == None : d_customs.erro(self.parent, 'حدد بحر القصيدة'); return
            rawi = 0
            kafia = 0
            arodh = 0
        else:
            baher = 0
            rawi = 0
            kafia = 0
            arodh = 0
        gharadh = d_customs.value_active(self.gharadh)
        if gharadh == None : d_customs.erro(self.parent, 'حدد غرض القصيدة'); return
        poet, sex, balad, age = self.add_poet()
        if poet == 'none': return
        charh = self.charh_bfr.get_text(self.charh_bfr.get_start_iter(),
                                        self.charh_bfr.get_end_iter(), False)
        sabab = self.sabab_bfr.get_text(self.sabab_bfr.get_start_iter(),
                                        self.sabab_bfr.get_end_iter(), False)
        label = Gtk.Label()
        label.override_font(Pango.FontDescription('KacstOne 15'))
        if naw3 != 5:
            if d_tools.is_machtor(text):
                longer_half, n_abiat = d_tools.longer_half(text, label, 1)
            else:
                longer_half, n_abiat = d_tools.longer_half(text, label, 0)
        else: 
            longer_half = 0
            n_abiat = len(text.splitlines(1))
        check = self.parent.db.add_poem(nam, text, sabab, charh, poet, sex, balad, age, 
                                 n_abiat, baher, rawi, kafia, arodh, gharadh, naw3, longer_half)
        self.parent.organiz.refresh_poets()
        self.parent.organiz.search_cb()
        if check == None: d_customs.info(self.parent, 'تم إضافة القصيدة بنجاح'); return
   
    def change_naw3(self, *a):
        if self.naw3.get_active() == 0:
            self.baher.set_sensitive(True)
            self.rawi.set_sensitive(True)
            self.kafia.set_sensitive(True)
            self.arodh.set_sensitive(True)
        elif self.naw3.get_active() == 1:
            self.baher.set_sensitive(True)
            self.rawi.set_active(-1)
            self.kafia.set_active(-1)
            self.arodh.set_active(-1)
            self.rawi.set_sensitive(False)
            self.kafia.set_sensitive(False)
            self.arodh.set_sensitive(False)
        else:
            self.baher.set_active(-1)
            self.rawi.set_active(-1)
            self.kafia.set_active(-1)
            self.arodh.set_active(-1)
            self.baher.set_sensitive(False)
            self.rawi.set_sensitive(False)
            self.kafia.set_sensitive(False)
            self.arodh.set_sensitive(False)
    
    def a3aridh_elbaher(self, *a):
        if self.baher.get_active() == -1: return
        model = self.arodh.get_model()
        model.clear()
        baher = d_customs.value_active(self.baher)
        a3aridh = d_tools.ela3aridh_in_behor[baher]
        for a in a3aridh:
            nm = d_tools.get_name(d_tools.ela3aridh, a)
            model.append([a, nm])
    
    def select_age(self, *a):
        if d_customs.value_active(self.ages) == 8: self.lands.set_sensitive(True)
        else:
            self.lands.set_active(-1)
            self.lands.set_sensitive(False)
    
    def tashkeel_cb(self, btn, haraka):
        self.nasse_bfr.insert_at_cursor(haraka)    
    
    def near_page(self, v):
        self.size_font += v
        self.charh.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
        self.nasse.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
        self.sabab.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
        self.tarjama.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
    
    def replace_all(self, *a):
        dlg = Gtk.Dialog(parent=self.parent)
        dlg.set_icon_name("asmaa")
        area = dlg.get_content_area()
        area.set_border_width(3)
        dlg.set_title('إيجاد واستبدال')
        text_old = Gtk.Entry()
        text_old.set_placeholder_text('النص القديم')
        if self.nasse_bfr.get_has_selection():
            sel = self.nasse_bfr.get_selection_bounds()
            text = self.nasse_bfr.get_text(sel[0], sel[1],True)
            text_old.set_text(text)
        text_new = Gtk.Entry()
        text_new.set_placeholder_text('النص الجديد')
        use_re = Gtk.CheckButton('استعمل التعبيرات المنتظمة')
        clo = Gtk.Button("إغلاق")
        clo.connect('clicked',lambda *a: dlg.destroy())
        rpl = Gtk.Button("استبدل الكل")
        def replace_cb(widget):
            old_t = self.nasse_bfr.get_text(self.nasse_bfr.get_start_iter(),
                            self.nasse_bfr.get_end_iter(), False)
            if use_re.get_active():
                new_t = re.sub(text_old.get_text(), text_new.get_text(), old_t)
            else:
                new_t = old_t.replace(text_old.get_text(), text_new.get_text())
            self.nasse_bfr.set_text(new_t)
        rpl.connect('clicked', replace_cb)
        hb = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
        box = Gtk.Box(spacing=5,orientation=Gtk.Orientation.VERTICAL)
        hb.pack_start(rpl, False, False, 0)
        hb.pack_end(clo, False, False, 0)
        box.pack_start(text_old, False, False, 0)
        box.pack_start(text_new, False, False, 0)
        box.pack_start(use_re, False, False, 0)
        box.pack_start(hb, False, False, 0)
        area.pack_start(box, True, True, 0)
        dlg.show_all()
    
    def change_text(self, *a):
        text = (self.nasse_bfr.get_text(self.nasse_bfr.get_start_iter(), self.nasse_bfr.get_end_iter(), False))
        self.list_modifieds.append(text)
        if len(self.list_modifieds) > 1:
            self.redo.set_sensitive(True)
    
    def redo_text(self, *a):
        del self.list_modifieds[-1]
        self.nasse_bfr.set_text(self.list_modifieds[-1])
        del self.list_modifieds[-1]
        del self.list_modifieds[-1]
        if len(self.list_modifieds) == 1:
            self.redo.set_sensitive(False)   
    
    def __init__(self, parent):
        self.parent = parent
        self.list_modifieds = []
        self.size_font = int(self.parent.theme.fontch[-2:])
        Gtk.Box.__init__(self,spacing=3, orientation=Gtk.Orientation.VERTICAL)
        self.nbk = Gtk.Notebook()
        
        self.nasse = d_customs.ViewEdit()
        self.nasse_bfr = self.nasse.get_buffer()
        self.nasse_bfr.connect('changed', self.change_text)
        self.nasse.connect_after("populate-popup", self.populate_popup)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.nasse)
        vb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.VERTICAL)
        
        hb1 = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        hb1.set_border_width(3)
        hb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(hb.get_style_context(), "linked")
        lab = Gtk.Label('التشكيل :   ')
        lab.set_alignment(0,0.5)
        hb1.pack_start(lab, False, False, 0)
        shadda = d_customs.tool_button(join(d_customs.ICON_DIR, 'shadda.png'), 'الشدة', self.tashkeel_cb, d_araby.SHADDA)
        hb.pack_start(shadda, False, False, 0)
        skon = d_customs.tool_button(join(d_customs.ICON_DIR, 'skon.png'), 'السكون',self.tashkeel_cb, d_araby.SUKUN)
        hb.pack_start(skon, False, False, 0)
        fatha = d_customs.tool_button(join(d_customs.ICON_DIR, 'fatha.png'), 'الفتحة',self.tashkeel_cb, d_araby.FATHA)
        hb.pack_start(fatha, False, False, 0)
        damma = d_customs.tool_button(join(d_customs.ICON_DIR, 'damma.png'), 'الضمة',self.tashkeel_cb, d_araby.DAMMA)
        hb.pack_start(damma, False, False, 0)
        kasra = d_customs.tool_button(join(d_customs.ICON_DIR, 'kasra.png'), 'الكسرة',self.tashkeel_cb, d_araby.KASRA)
        hb.pack_start(kasra, False, False, 0)
        fatha2 = d_customs.tool_button(join(d_customs.ICON_DIR, 'fatha2.png'), 'الفتحتين',self.tashkeel_cb, d_araby.FATHATAN)
        hb.pack_start(fatha2, False, False, 0)
        damma2 = d_customs.tool_button(join(d_customs.ICON_DIR, 'damma2.png'), 'الضمتين',self.tashkeel_cb, d_araby.DAMMATAN)
        hb.pack_start(damma2, False, False, 0)
        kasra2 = d_customs.tool_button(join(d_customs.ICON_DIR, 'kasra2.png'), 'الكسرتين',self.tashkeel_cb, d_araby.KASRATAN)
        hb.pack_start(kasra2, False, False, 0)
        hb1.pack_start(hb, False, False, 0)
        self.redo = Gtk.ToolButton(stock_id=Gtk.STOCK_REDO)
        self.redo.set_sensitive(False)
        hb1.pack_end(self.redo, False, False, 3)
        self.redo.connect('clicked', self.redo_text)
        
        self.replace = Gtk.ToolButton(stock_id=Gtk.STOCK_FIND_AND_REPLACE)
        hb1.pack_end(self.replace, False, False, 3)
        self.replace.connect('clicked', self.replace_all)
        vb.pack_start(scroll, True, True, 0)
        vb.pack_start(hb1, False, False, 0)
        lab = Gtk.Label('نص القصيدة')
        lab.set_size_request(150, -1)
        self.nbk.append_page(vb, lab)
        
        self.vb_info = Gtk.Box(spacing=5, orientation=Gtk.Orientation.VERTICAL)
        self.vb_info.set_border_width(6)
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        la0 = Gtk.Label('اسم القصيدة')
        la0.set_alignment(0,0.5)
        hb.pack_start(la0, False, False, 0)
        self.name_poem = Gtk.Entry()
        self.name_poem.set_placeholder_text('إن لم يكن لها اسم ، اكتب صدر أول بيت بدلا من ذلك')
        hb.pack_start(self.name_poem, True, True, 0)
        self.vb_info.pack_start(hb, False, False, 0)
        
        hb, self.naw3 = d_customs.combo(d_tools.elnaw3, 'النوع', 0)
        self.vb_info.pack_start(hb, False, False, 0)
        self.naw3.connect('changed', self.change_naw3)
        
        hb, self.gharadh = d_customs.combo(d_tools.elgharadh, 'الغرض', 0)
        self.vb_info.pack_start(hb, False, False, 0)
        
        hb, self.baher = d_customs.combo(d_tools.elbehor, 'البحر', 0)
        self.baher.connect('changed', self.a3aridh_elbaher)
        self.vb_info.pack_start(hb, False, False, 0)
        
        hb, self.rawi = d_customs.combo(d_tools.elrawi, 'الروي', 0)
        self.vb_info.pack_start(hb, False, False, 0)
        
        hb, self.kafia = d_customs.combo(d_tools.elkawafi, 'القافية', 0)
        self.vb_info.pack_start(hb, False, False, 0)
        
        hb, self.arodh = d_customs.combo(d_tools.ela3aridh, 'العروض وضربها', 0)
        self.vb_info.pack_start(hb, False, False, 0)
        
        self.sabab = d_customs.ViewEdit()
        self.sabab_bfr = self.sabab.get_buffer()
        self.sabab_bfr.set_text('سبب النظم')
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.sabab)
        self.vb_info.pack_start(scroll, True, True, 0)
        lab = Gtk.Label('معلومات القصيدة')
        lab.set_size_request(150, -1)
        self.nbk.append_page(self.vb_info, lab)
        
        self.charh = d_customs.ViewEdit()
        self.charh_bfr = self.charh.get_buffer()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.charh)
        lab = Gtk.Label('شرح القصيدة')
        lab.set_size_request(150, -1)
        self.nbk.append_page(scroll, lab)
        
        vbox = Gtk.Box(spacing=3,orientation=Gtk.Orientation.VERTICAL)
        
        hbox = Gtk.Box(spacing=15,orientation=Gtk.Orientation.HORIZONTAL)
        hbox.set_border_width(3)
        self.outsider = Gtk.RadioButton.new_with_label_from_widget(None,'لا يعرف قائله')
        self.outsider.connect('toggled',self.is_poet,'1')
        hbox.pack_start(self.outsider, False, False, 0)

        self.present = Gtk.RadioButton.new_with_label_from_widget(self.outsider,'موجود في قاعدة البيانات')
        self.present.connect('toggled',self.is_poet,'2')
        hbox.pack_start(self.present, False, False, 0)
        
        self.nopresent = Gtk.RadioButton.new_with_label_from_widget(self.outsider,'غير موجود في قاعدة البيانات')
        self.nopresent.connect('toggled',self.is_poet,'3')
        hbox.pack_start(self.nopresent, False, False, 0)
        vbox.pack_start(hbox, False, False, 0)
        
        
        self.notebook_down = Gtk.Notebook()
        self.notebook_down.set_show_tabs(False)
        hbox = Gtk.Box(spacing=3,orientation=Gtk.Orientation.HORIZONTAL)
        self.notebook_down.append_page(hbox, Gtk.Label("0"))
        
        vb = Gtk.Box(spacing=3,orientation=Gtk.Orientation.VERTICAL)
        vb.set_border_width(3)
        self.poets = Gtk.Entry()
        self.poets.set_placeholder_text('اكتب حرفا لتحصل على التكملة')
        self.completion03 = Gtk.EntryCompletion()
        self.completion03.set_model(self.parent.organiz.store_poet)
        self.completion03.set_text_column(1)
        self.poets.set_completion(self.completion03)
        vb.pack_start(self.poets, False, False, 0)
        self.notebook_down.append_page(vb, Gtk.Label("1"))
        vbox.pack_start(self.notebook_down, True, True, 0)
        
        vb_poet = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        vb_poet.set_border_width(3)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(Gtk.Label('الاسم المشتهر'), False, False, 0)
        self.lak_poet = Gtk.Entry()
        hb.pack_start(self.lak_poet, True, True, 0)
        vb_poet.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(Gtk.Label('الاسم الحقيقي'), False, False, 0)
        self.nm_poet = Gtk.Entry()
        hb.pack_start(self.nm_poet, True, True, 0)
        vb_poet.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=33, orientation=Gtk.Orientation.HORIZONTAL)
        hb1, self.ages = d_customs.combo(d_tools.age_poet, 'العصر', 0)
        self.ages.connect('changed', self.select_age)
        hb.pack_start(hb1, False, False, 0)
        
        hb1, self.lands = d_customs.combo(d_tools.elbalad, 'البلد', 0)
        hb.pack_start(hb1, False, False, 0)
        vb_poet.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=33, orientation=Gtk.Orientation.HORIZONTAL)
        hb1, self.sexs = d_customs.combo(d_tools.sex_poet, 'الجنس', 0)
        hb.pack_start(hb1, False, False, 0)
        
        hb1 = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        adj = Gtk.Adjustment(1435, -300, 1435, 1, 5.0, 0.0)
        self.dh_poet = Gtk.SpinButton()
        self.dh_poet.set_adjustment(adj)
        self.dh_poet.set_wrap(True)
        self.dh_poet.set_sensitive(False)
        self.death = Gtk.CheckButton('الوفاة (هـ)')
        hb1.pack_start(self.death, False, False, 0)
        hb1.pack_start(self.dh_poet, False, False, 0)
        hb.pack_start(hb1, False, False, 0)
        vb_poet.pack_start(hb, False, False, 0)
        def is_dh(widget, *a):
            if self.death.get_active():
                self.dh_poet.set_sensitive(True)
            else:
                self.dh_poet.set_sensitive(False)
        self.death.connect('toggled', is_dh)
        
        self.tarjama = d_customs.ViewEdit()
        self.tarjama_bfr = self.tarjama.get_buffer()
        self.tarjama_bfr.set_text('ترجمة الشاعر')
        self.tarjama_scroll = Gtk.ScrolledWindow()
        self.tarjama_scroll.set_shadow_type(Gtk.ShadowType.IN)
        self.tarjama_scroll.add(self.tarjama)
        vb_poet.pack_start(self.tarjama_scroll, True, True, 0)
        self.notebook_down.append_page(vb_poet, Gtk.Label("2"))
        lab = Gtk.Label('الشاعر')
        lab.set_size_request(150, -1)
        self.nbk.append_page(vbox, lab)
        
        hbox = Gtk.Box(spacing=3,orientation=Gtk.Orientation.HORIZONTAL)
        self.accept = Gtk.Button('إضافة القصيدة')
        self.accept.connect('clicked',self.adding)
        hbox.pack_start(self.accept, False, False, 0)
        
        self.all_poems = Gtk.CheckButton('نمط إضافة عدة قصائد')
        def all_poems_cb(widget, *a):
            if self.all_poems.get_active():
                self.vb_info.set_sensitive(False)
            else:
                self.vb_info.set_sensitive(True)
        self.all_poems.connect('toggled', all_poems_cb)
        hbox.pack_start(self.all_poems, False, False, 0)

        self.pack_start(self.nbk, True, True, 0)
        self.pack_start(hbox, False, False, 0)
        
        self.show_all()
        