# -*- coding: utf-8 -*-

#a############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
#a############################################################################

from gi.repository import Gtk
import d_customs, d_config

# class نافذة المعاجم---------------------------------------------------------    

class Face(Gtk.Box):
    
    def search_on_page(self, text):
        n = self.face_notebook.get_current_page()
        ch = self.face_notebook.get_nth_page(n)
        ch.search_on_page(text)
    
    def search_on_active(self, text):
        n = self.face_notebook.get_current_page()
        ch = self.face_notebook.get_nth_page(n)
        ch.search_on_active(text)
    
    def near_page(self, v):
        n = self.face_notebook.get_current_page()
        ch = self.face_notebook.get_nth_page(n)
        ch.near_page(v)
    
    def toggled_btn_cb(self, btn):
        if btn.get_active():
            for a in self.list_btn:
                if btn != a: a.set_active(False)
            if btn.get_name() in ['0', '1', '2', '4']:
                self.face_notebook.set_current_page(0)
                self.parent.favorites.show_page(btn.get_name())
            elif btn.get_name() == '3':
                self.face_notebook.set_current_page(1)
            elif btn.get_name() == '5':
                self.face_notebook.set_current_page(2)
            elif btn.get_name() == '6':
                self.face_notebook.set_current_page(3)
            elif btn.get_name() == '7':
                self.face_notebook.set_current_page(4)
            d_config.setv('start', btn.get_name()) 
    
    def switch_page(self, widget, page, n):
        if n == 1: self.parent.entry_search.set_placeholder_text('بحث في النص')
        elif n == 3: self.parent.entry_search.set_placeholder_text('بحث في النص/المعجم')
        elif n == 2: self.parent.entry_search.set_placeholder_text('بحث في النص')
        else: self.parent.entry_search.set_placeholder_text('بحث في النص')
    
    def __init__(self, parent):
        self.parent = parent
        Gtk.Box.__init__(self, orientation=Gtk.Orientation.VERTICAL)
        #- face_notebook-----------------------------
        self.face_notebook = Gtk.Notebook()
        self.face_notebook.set_scrollable(True)
        self.face_notebook.set_show_tabs(False)
        self.face_notebook.append_page(self.parent.favorites, Gtk.Label("0"))
        self.face_notebook.append_page(self.parent.my_abiat, Gtk.Label("1"))
        self.face_notebook.append_page(self.parent.metrics, Gtk.Label("2"))
        self.face_notebook.append_page(self.parent.my_dict, Gtk.Label("3"))
        self.face_notebook.append_page(self.parent.my_fun, Gtk.Label("4"))
        self.face_notebook.connect("switch-page", self.switch_page)
        hbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        hbox.set_homogeneous(False)
        Gtk.StyleContext.add_class(hbox.get_style_context(), "linked")
        
        self.list_btn = []
        list_btn0 = [
                     ('القصائد الأخيرة', 'history-btn.png'),
                     ('مفضلة الدواوين', 'dawawin-btn.png'),
                     ('مفضلة القصائد', 'poems-btn.png'),
                     ('مفضلة الأبيات', 'abiat-btn.png'),
                     ('قصائد مسموعة', 'recite-btn.png'),
                     ('عروض وقوافي', 'awzan-btn.png'),
                     ('معاجم عربية', 'dict-btn.png'),
                     ('تسلية وترفيه', 'fun-btn.png')
                     ]
        
        for a in list_btn0:
            btn = d_customs.ButtonFace(a[0], a[1])
            self.list_btn.append(btn)
            btn.set_name(str(list_btn0.index(a, )))
            btn.connect('toggled', self.toggled_btn_cb)
            hbox.pack_start(btn, False, False, 0)
        
        box = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        box.set_border_width(5)
        box.pack_start(hbox, True, False, 0)
        self.pack_start(self.face_notebook, True, True, 0)
        self.pack_end(box, False, False, 0)