# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from gi.repository import Gtk, Gdk, Pango
from d_contacts import MyDB
import d_customs, d_tools, d_araby
import random


# class صفحة التسلية-------------------------------------------------------------------    

class MyFun(Gtk.Notebook):
    
    def search_on_page(self, text):
        return
    
    def near_page(self, v):
        return
    
    # a عند الضغط على اعتمد في صفحة المساجلة---------------------------------------
    
    def ok_verse_cb(self, *a):
        self.set_sensitive(False)
        while (Gtk.events_pending()): Gtk.main_iteration()
        all_verse = self.verse_all_bfr.get_text(self.verse_all_bfr.get_start_iter(),
                self.verse_all_bfr.get_end_iter(), False)
        verse0 = self.verse_prog_bfr.get_text(self.verse_prog_bfr.get_start_iter(),
                self.verse_prog_bfr.get_end_iter(), False)
        rawi0 = d_araby.NAMES[d_tools.rawi_poem(verse0.strip())]
        verse1 = self.verse_usr_bfr.get_text(self.verse_usr_bfr.get_start_iter(),
                self.verse_usr_bfr.get_end_iter(), False)
        if verse1 == '' :
            self.set_sensitive(True) 
            return
        rawi1 = d_araby.NAMES[d_tools.rawi_poem(verse1.strip())]
        first1 = d_araby.NAMES[verse1.strip()[0]]
        if first1 != rawi0:
            d_customs.erro(self.parent, 'البيت يبدأ بحرف غير الذي انتهى به الأول\nحاول مجددا .')
            self.set_sensitive(True)
            return
        if self.db.is_verse(verse1):
            if d_araby.fuzzy_plus(verse1) in d_araby.fuzzy_plus(all_verse):
                d_customs.erro(self.parent, 'البيت مستخدم مسبقا\nحاول مجددا .')
                self.set_sensitive(True)
                return
            else:
                d_customs.info(self.parent, 'أحسنت')
                self.set_sensitive(True)
                self.verse_all_bfr.insert(self.verse_all_bfr.get_end_iter(), '\nالمستخدم : '+verse1.strip())
                d = int(self.lab_answer_user.get_label())+1
                self.lab_answer_user.set_label(str(d))
                self.next_verse(rawi1)
        else:
            d_customs.erro(self.parent, 'البيت غير موجود في قاعدة بيانات البرنامج\nحاول مجددا .')
            self.set_sensitive(True)
            return
        d_customs.with_tag(self.verse_all_bfr, self.verse_all_tag, ['البرنامج :','المستخدم :'])
        self.verse_all.scroll_to_iter(self.verse_all_bfr.get_end_iter(), 0, 1, 1, 1)
    
    # a عند الضغط على جديد في صفحة المساجلة---------------------------------------
    
    def skip_verse_cb(self, *a):
        self.new_verse_debate()
    
    # a معالجة التقييم في صفحة من القائل ؟--------------------------------------------
    
    def appraisal_who(self, *a):
        c = int(self.lab_correct_who.get_label())
        f = int(self.lab_false_who.get_label())
        s = int(self.lab_skip_who.get_label())
        if c == 0 and f == 0:
            t = (c*100)/(s+c)
        elif c == 0 and s == 0:
            t = (c*100)/(c+f)
        else:
            t = (((c*100)/(s+c))+((c*100)/(c+f)))/2
        ls_appraisal = ['سيئ','ضعيف','متوسط','حسن','جيد','ممتاز']
        if t == 0: t = 15
        self.lab_appraisal_who.set_label(ls_appraisal[int(t/15)-1])
        
    # a معالجة التقييم في صفحة أي بحر ؟--------------------------------------------
    
    def appraisal_baher(self, *a):
        c = int(self.lab_correct_baher.get_label())
        f = int(self.lab_false_baher.get_label())
        s = int(self.lab_skip_baher.get_label())
        if c == 0 and f == 0:
            t = (c*100)/(s+c)
        elif c == 0 and s == 0:
            t = (c*100)/(c+f)
        else:
            t = (((c*100)/(s+c))+((c*100)/(c+f)))/2
        ls_appraisal = ['سيئ','ضعيف','متوسط','حسن','جيد','ممتاز']
        if t == 0: t = 15
        self.lab_appraisal_baher.set_label(ls_appraisal[int(t/15)-1])
    
    # a عند الضغط على أجب في صفحة من القائل ؟-----------------------------------------
    
    def answer_who_cb(self, *a):
        self.choice_1.set_sensitive(False)
        self.choice_2.set_sensitive(False)
        self.choice_3.set_sensitive(False)
        self.answer_who.set_sensitive(False)
        d_customs.info(self.parent, 'القائل هو {}'.format(self.who_speaker, ))
        d = int(self.lab_skip_who.get_label())+1
        self.lab_skip_who.set_label(str(d))
        self.new_verse_who()
        self.appraisal_who()
    
    # a عند الضغط على جديد في صفحة من القائل ؟----------------------------------------- 
    
    def new_who_cb(self, *a):
        if self.choice_1.get_active() or self.choice_2.get_active() or self.choice_3.get_active():
            pass
        else:
            d = int(self.lab_skip_who.get_label())+1
            self.lab_skip_who.set_label(str(d))
        self.new_verse_who()
        self.appraisal_who()
        
    # a عند الضغط على أجب في صفحة أي بحر ؟-----------------------------------------
    
    def answer_baher_cb(self, *a):
        self.choice_baher1.set_sensitive(False)
        self.choice_baher2.set_sensitive(False)
        self.choice_baher3.set_sensitive(False)
        self.answer_baher.set_sensitive(False)
        d_customs.info(self.parent, 'البحر هو {}'.format(self.name_baher, ))
        d = int(self.lab_skip_baher.get_label())+1
        self.lab_skip_baher.set_label(str(d))
        self.new_verse_baher()
        self.appraisal_baher()
    
    # a عند الضغط على جديد في صفحة أي بحر ؟----------------------------------------- 
    
    def new_baher_cb(self, *a):
        if self.choice_baher1.get_active() or self.choice_baher2.get_active() or self.choice_baher3.get_active():
            pass
        else:
            d = int(self.lab_skip_baher.get_label())+1
            self.lab_skip_baher.set_label(str(d))
        self.new_verse_baher()
        self.appraisal_baher()
     
    # a عند الضغط على أجب في صفحة المساجلة---------------------------------------
        
    def answer_verse_cb(self, *a):
        verse = self.verse_prog_bfr.get_text(self.verse_prog_bfr.get_start_iter(),
                self.verse_prog_bfr.get_end_iter(), False)
        rawi = d_araby.NAMES[d_tools.rawi_poem(verse.strip())]
        self.verse_all_bfr.insert(self.verse_all_bfr.get_end_iter(), '\nالمستخدم : لم يجب')
        self.next_verse(rawi)
        d_customs.with_tag(self.verse_all_bfr, self.verse_all_tag, ['البرنامج :','المستخدم :'])
        self.verse_all.scroll_to_iter(self.verse_all_bfr.get_end_iter(), 0, 1, 1, 1)
    
    # a البيت الجديد الخاص بالبرنامج في صفحة المساجلة---------------------------- 
    
    def next_verse(self, rawi):
        all_verse = self.verse_all_bfr.get_text(self.verse_all_bfr.get_start_iter(),
                self.verse_all_bfr.get_end_iter(), False)
        if rawi == 'همزة':
            r = 'أ'
        elif rawi == 'ألف':
            r = 'ا'
        else:
            r = rawi[0]
        poems = self.db.first_in_verse(r)
        random.shuffle(poems)
        if len(poems) == 0: 
            d_customs.erro(self.parent, 'لا يوجد بيت جديد يبدأ بحرف {}'.format(rawi,))
            return
        else:
            for a in poems:
                nasse = self.db.get_poem(a[0])[0]
                ls = nasse.splitlines(1)
                for b in ls:
                    if '*' in b and b[0] == r:
                        if d_araby.fuzzy_plus(b) not in d_araby.fuzzy_plus(all_verse):
                            self.verse_prog_bfr.set_text(b.strip())
                            self.verse_all_bfr.insert(self.verse_all_bfr.get_end_iter(), '\nالبرنامج : '+b.strip())
                            d = int(self.lab_answer_prog.get_label())+1
                            self.lab_answer_prog.set_label(str(d))
                            self.verse_usr_bfr.set_text('')
                            i = self.db.id_poet(a[0])
                            self.lab_speaker0.set_label(self.db.name_poet(i)[1])
                            self.lab_speaker0.set_name(str(i))
                            if b == None: continue
                            r = self.db.rawi_poem(a[0])
                            rawi = d_araby.NAMES[d_tools.rawi_poem(b.strip())]
                            self.lab_rawi.set_label(rawi)
                            return
            d_customs.erro(self.parent, 'لا يوجد بيت جديد يبدأ بحرف {}'.format(rawi,))
    
    # a معالجة التقييم في صفحة رتب البيت-------------------------------------------- 
    
    def appraisal(self, *a):
        c = int(self.lab_correct.get_label())
        f = int(self.lab_false.get_label())
        s = int(self.lab_skip.get_label())
        if c == 0 and f == 0:
            t = int((c*100)/(s+c))
        elif c == 0 and s == 0:
            t = int((c*100)/(c+f))
        else:
            t = int((((c*100)/(s+c))+((c*100)/(c+f)))/2)
        ls_appraisal = ['سيئ','ضعيف','متوسط','حسن','جيد','ممتاز']
        if t == 0: t = 15
        self.lab_appraisal.set_label(ls_appraisal[int(t/15)-1])
    
    # a عند الضغط على تحقق في صفحة رتب البيت-------------------------------------------- 
    
    def check_verse_cb(self, *a):
        half1 = ''
        half2 = ''
        if self.verse == None : return
        l_v = self.verse.split('*')
        chs1 = self.box_half1.get_children()
        for ch1 in chs1:
            nm = ch1.get_name()
            half1 += nm+" "
        chs2 = self.box_half2.get_children()
        for ch2 in chs2:
            nm = ch2.get_name()
            half2 += nm+" "
        if half1.strip() == l_v[0].strip() and half2.strip() == l_v[1].strip():
            d_customs.info(self.parent, 'أحسنت ..!!!')
            d = int(self.lab_correct.get_label())+1
            self.lab_correct.set_label(str(d))
            self.new_verse_organize()
        else:
            d_customs.info(self.parent, 'حاول مرة أخرى ..!!!')
            d = int(self.lab_false.get_label())+1
            self.lab_false.set_label(str(d))
        self.appraisal()
    
    # a عند الضغط على جديد في صفحة رتب البيت-------------------------------------------- 
    
    def new_verse_cb(self, *a):
        self.new_verse_organize()
        if self.verse == None : return
        d = int(self.lab_skip.get_label())+1
        self.lab_skip.set_label(str(d))
        self.appraisal()
        self.check_verse.set_sensitive(True)
    
    # a ترتيب البيت آليا في صفحة رتب البيت----------------------------------
    
    def org_verse_cb(self, *a):
        if self.verse == None : return
        lst_verse = self.verse.split('*')
        lst_half1 = lst_verse[0].strip().split(' ')
        lst_half2 = lst_verse[1].strip().split(' ')
        #---------------------
        chs1 = self.box_half1.get_children()
        for ch1 in chs1:
            ch1.destroy()
        for a1 in lst_half1:
            btn = d_customs.Buttonfun(a1, self.parent.theme)
            btn.connect('clicked', self.org_btn, 1)
            self.box_half1.pack_start(btn, False, False, 0)
        #--------------------------    
        chs2 = self.box_half2.get_children()
        for ch2 in chs2:
            ch2.destroy()
        for a2 in lst_half2:
            btn = d_customs.Buttonfun(a2, self.parent.theme)
            btn.connect('clicked', self.org_btn, 2)
            self.box_half2.pack_start(btn, False, False, 0)
        self.box_half1.show_all()
        self.box_half2.show_all()
        self.check_verse.set_sensitive(False)
    
    # a عند الضغط على كلمة في صفحة رتب البيت------------------------------------
    
    def org_btn(self, btn, v):
        a1 = btn.get_name()
        btn.destroy()
        btn_new = d_customs.Buttonfun(a1, self.parent.theme)
        if v == 1:
            btn_new.connect('clicked', self.org_btn, 1)
            self.box_half1.pack_start(btn_new, False, False, 0)
            self.box_half1.show_all()
        elif v == 2:
            btn_new.connect('clicked', self.org_btn, 2)
            self.box_half2.pack_start(btn_new, False, False, 0)
            self.box_half2.show_all()
    
    # a عند اختيار القائل في صفحة من القائل----------------------------------------
        
    def choice_speaker(self, *a):
        self.choice_1.set_sensitive(False)
        self.choice_2.set_sensitive(False)
        self.choice_3.set_sensitive(False)
        self.answer_who.set_sensitive(False)
        if self.choice_1.get_active() and self.lab_speaker_1.get_text() == self.who_speaker:
            d_customs.info(self.parent, 'أحسنت القائل هو {}'.format(self.who_speaker, ))
            d = int(self.lab_correct_who.get_label())+1
            self.lab_correct_who.set_label(str(d))
        elif self.choice_2.get_active() and self.lab_speaker_2.get_text() == self.who_speaker:
            d_customs.info(self.parent, 'أحسنت القائل هو {}'.format(self.who_speaker, ))
            d = int(self.lab_correct_who.get_label())+1
            self.lab_correct_who.set_label(str(d))
        elif self.choice_3.get_active() and self.lab_speaker_3.get_text() == self.who_speaker:
            d_customs.info(self.parent, 'أحسنت القائل هو {}'.format(self.who_speaker, ))
            d = int(self.lab_correct_who.get_label())+1
            self.lab_correct_who.set_label(str(d))
        else:
            if self.choice_1.get_active() or self.choice_2.get_active() or self.choice_3.get_active():
                d_customs.erro(self.parent, 'أخطأت !! القائل هو {}'.format(self.who_speaker, ))
                d = int(self.lab_false_who.get_label())+1
                self.lab_false_who.set_label(str(d))
        self.new_verse_who()
        self.appraisal_who()
    
    # a عند اختيار البحر في صفحة أي بحر----------------------------------------
        
    def choice_baher(self, *a):
        self.choice_baher1.set_sensitive(False)
        self.choice_baher2.set_sensitive(False)
        self.choice_baher3.set_sensitive(False)
        self.answer_baher.set_sensitive(False)
        if self.choice_baher1.get_active() and self.lab_baher_1.get_text() == self.name_baher:
            d_customs.info(self.parent, 'أحسنت البحر هو {}'.format(self.name_baher, ))
            d = int(self.lab_correct_baher.get_label())+1
            self.lab_correct_baher.set_label(str(d))
        elif self.choice_baher2.get_active() and self.lab_baher_2.get_text() == self.name_baher:
            d_customs.info(self.parent, 'أحسنت البحر هو {}'.format(self.name_baher, ))
            d = int(self.lab_correct_baher.get_label())+1
            self.lab_correct_baher.set_label(str(d))
        elif self.choice_baher3.get_active() and self.lab_baher_3.get_text() == self.name_baher:
            d_customs.info(self.parent, 'أحسنت البحر هو {}'.format(self.name_baher, ))
            d = int(self.lab_correct_baher.get_label())+1
            self.lab_correct_baher.set_label(str(d))
        else:
            if self.choice_baher1.get_active() or self.choice_baher2.get_active() or self.choice_baher3.get_active():
                d_customs.erro(self.parent, 'أخطأت !! البحر هو {}'.format(self.name_baher, ))
                d = int(self.lab_false_baher.get_label())+1
                self.lab_false_baher.set_label(str(d))
        self.new_verse_baher()
        self.appraisal_baher()
    
    # a إعادة بيت ومعرف قصيدته بعد اختياره  عشوائيا------------------------------------
        
    def chose_verse(self, *a):
        list_poems_id = self.db.all_poems_id()
        if len(list_poems_id)== 0 : return
        id_poem = random.choice(list_poems_id)
        poem, sb, ch, t3 = self.db.get_poem(id_poem)
        if '*' in poem:
            lst_new = []
            lst_poem = poem.splitlines(1)
            for a in lst_poem:
                if '*' in a:
                    lst_new.append(a)
            verse = random.choice(lst_new)
            if len(verse) > 10:
                return verse, id_poem
            else:
                self.chose_verse()
    
    # a بيت جديد في صفحة من القائل ؟-------------------------------------------- 
            
    def new_verse_who(self, *a):
        try: verse, id_poem = self.chose_verse()
        except: return
        i = self.db.id_poet(id_poem)
        self.who_speaker = self.db.name_poet(i)[1]
        if verse == None: return
        self.verse_who_bfr.set_text(verse.strip())
        i1, i2 = self.db.two_poet(i)
        who_speaker_1 = self.db.name_poet(i1)[1]
        who_speaker_2 = self.db.name_poet(i2)[1]
        ls = [self.who_speaker, who_speaker_1, who_speaker_2]
        random.shuffle(ls)
        self.lab_speaker_1.set_text(ls[0])
        self.lab_speaker_2.set_text(ls[1])
        self.lab_speaker_3.set_text(ls[2])
        self.choice_1.set_active(False)
        self.choice_2.set_active(False)
        self.choice_3.set_active(False)
        self.choice_1.set_sensitive(True)
        self.choice_2.set_sensitive(True)
        self.choice_3.set_sensitive(True)
        self.answer_who.set_sensitive(True)
        
    # a بيت جديد في صفحة أي بحر ؟-------------------------------------------- 
            
    def new_verse_baher(self, *a):
        try: verse, id_poem = self.chose_verse()
        except: return
        e = self.db.id_poet(id_poem)
        self.lab_speaker1.set_label(self.db.name_poet(e)[1])
        self.lab_speaker1.set_name(str(e))
        i = self.db.get_id_baher(id_poem)
        self.name_baher = d_tools.get_name(d_tools.elbehor, i)
        if verse == None: return
        self.verse_baher_bfr.set_text(verse.strip())
        ls =[]
        for a in range(1,17):
            if a != i: ls.append(a)
        i1 = random.choice(ls)
        ls1 =  []
        for a in ls:
            if a != i1: ls1.append(a)
        i2 = random.choice(ls1)
        name_baher_1 = d_tools.get_name(d_tools.elbehor, i1)
        name_baher_2 = d_tools.get_name(d_tools.elbehor, i2)
        ls = [self.name_baher, name_baher_1, name_baher_2]
        random.shuffle(ls)
        self.lab_baher_1.set_text(ls[0])
        self.lab_baher_2.set_text(ls[1])
        self.lab_baher_3.set_text(ls[2])
        self.choice_baher1.set_active(False)
        self.choice_baher2.set_active(False)
        self.choice_baher3.set_active(False)
        self.choice_baher1.set_sensitive(True)
        self.choice_baher2.set_sensitive(True)
        self.choice_baher3.set_sensitive(True)
        self.answer_baher.set_sensitive(True)
    
    # a بيت جديد في صفحة المساجلة-------------------------------------------- 
        
    def new_verse_debate(self, *a):
        try: verse, id_poem = self.chose_verse()
        except: return
        i = self.db.id_poet(id_poem)
        self.lab_speaker0.set_label(self.db.name_poet(i)[1])
        id_poet = self.parent.db.id_poet(id_poem)
        self.lab_speaker0.set_name(str(id_poet))
        if verse == None: return
        r = self.db.rawi_poem(id_poem)
        rawi = d_araby.NAMES[d_tools.rawi_poem(verse.strip())]
        self.lab_rawi.set_label(rawi)
        self.verse_prog_bfr.set_text(verse.strip())
        self.verse_all_bfr.set_text('البرنامج : '+verse.strip())
        self.verse_usr_bfr.set_text('')
        self.lab_answer_prog.set_label('0')
        self.lab_answer_user.set_label('0')
    
    # a بيت جديد في صفحة رتب البيت--------------------------------------------        
        
    def new_verse_organize(self, *a):
        try: self.verse, id_poem = self.chose_verse()
        except: return
        i = self.db.id_poet(id_poem)
        self.lab_speaker.set_label(self.db.name_poet(i)[1])
        self.lab_speaker.set_name(str(i))
        if self.verse == None: return
        lst_verse = self.verse.split('*')
        lst_half1 = lst_verse[0].strip().split(' ')
        lst_half2 = lst_verse[1].strip().split(' ')
        random.shuffle(lst_half1)
        random.shuffle(lst_half2)
        #---------------------
        chs1 = self.box_half1.get_children()
        for ch1 in chs1:
            ch1.destroy()
        for a1 in lst_half1:
            btn = d_customs.Buttonfun(a1, self.parent.theme)
            btn.connect('clicked', self.org_btn, 1)
            self.box_half1.pack_start(btn, False, False, 0)
        #--------------------------    
        chs2 = self.box_half2.get_children()
        for ch2 in chs2:
            ch2.destroy()
        for a2 in lst_half2:
            btn = d_customs.Buttonfun(a2, self.parent.theme)
            btn.connect('clicked', self.org_btn, 2)
            self.box_half2.pack_start(btn, False, False, 0)
        self.box_half1.show_all()
        self.box_half2.show_all()
    
    def to_poet(self, btn, *a):
        id_poet = int(btn.get_name())
        if id_poet == 0: return 
        self.parent.dawawin_page.notebook.set_current_page(0)
        self.parent.main_notebook.set_current_page(1)
        self.parent.dawawin_page.to_poet(id_poet)
    
    def __init__(self, parent):
        self.parent = parent
        self.db = MyDB()
        Gtk.Notebook.__init__(self)
        
        # a --------------------------------------------
        vb1 = Gtk.Box(spacing=7, orientation=Gtk.Orientation.VERTICAL)
        vb1.set_border_width(7)
        
        hb1 = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        hb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(hb.get_style_context(), "linked")
        self.ok_verse = Gtk.Button('اعتمدْ')
        self.ok_verse.connect('clicked', self.ok_verse_cb)
        hb.pack_start(self.ok_verse, False, False, 0)
        self.answer_verse = Gtk.Button('أجبْ')
        self.answer_verse.connect('clicked', self.answer_verse_cb)
        hb.pack_start(self.answer_verse, False, False, 0)
        self.skip_verse = Gtk.Button('جديد')
        self.skip_verse.connect('clicked', self.skip_verse_cb)
        hb.pack_start(self.skip_verse, False, False, 0)
        self.lab_answer_prog = Gtk.Label(0)
        lab_1 = Gtk.Label('البرنامج : ')
        lab_1.set_alignment(0, 0.5)
        hb1.pack_start(hb, False, False, 0)
        hb1.pack_end(self.lab_answer_prog, False, False, 0)
        hb1.pack_end(lab_1, False, False, 0)
        vb1.pack_start(hb1, False, False, 0)
        
        self.verse_prog = d_customs.ViewClass()
        self.verse_prog_bfr = self.verse_prog.get_buffer()
        self.verse_prog.override_font(Pango.FontDescription('Simplified Naskh 22'))
        self.verse_prog.set_size_request(-1, 64)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.NEVER)
        scroll.add(self.verse_prog)
        vb1.pack_start(scroll, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        self.lab_speaker0 = Gtk.Button()
        self.lab_speaker0.set_relief(Gtk.ReliefStyle.NONE)
        self.lab_speaker0.connect('clicked', self.to_poet)
        hb.pack_start(self.lab_speaker0, False, False, 0)
        lab_1 = Gtk.Label('، الروي : ')
        lab_1.set_alignment(0, 0.5)
        hb.pack_start(lab_1, False, False, 0)
        self.lab_rawi = Gtk.Label()
        hb.pack_start(self.lab_rawi, False, False, 0)
        
        self.lab_answer_user = Gtk.Label(0)
        hb.pack_end(self.lab_answer_user, False, False, 0)
        lab_2 = Gtk.Label('       المستخدم : ')
        lab_2.set_alignment(0, 0.5)
        hb.pack_end(lab_2, False, False, 0)
        vb1.pack_start(hb, False, False, 0)
 
        self.verse_usr = d_customs.ViewEdit()
        self.verse_usr_bfr = self.verse_usr.get_buffer()
        self.verse_usr.override_font(Pango.FontDescription('Simplified Naskh 22'))
        self.verse_usr.set_size_request(-1, 64)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.NEVER)
        scroll.add(self.verse_usr)
        vb1.pack_start(scroll, False, False, 0)
        
        
        self.verse_all = d_customs.ViewClass()
        self.verse_all_bfr = self.verse_all.get_buffer()
        self.verse_all_tag = self.verse_all_bfr.create_tag("prog")
        self.verse_all_tag.set_property('foreground', self.parent.theme.coloran) 
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.verse_all)
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.AUTOMATIC)
        vb1.pack_start(scroll, True, True, 0)
        self.verse_all.override_font(Pango.FontDescription('Simplified Naskh 14'))
        self.new_verse_debate()
        lab = Gtk.Label('مساجلة شعرية')
        lab.set_size_request(150, -1)
        self.append_page(vb1, lab)
        
        # a --------------------------------------------
        vb2 = Gtk.Box(spacing=7, orientation=Gtk.Orientation.VERTICAL)
        vb2.set_border_width(7)
        
        hb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(hb.get_style_context(), "linked")
        self.answer_who = Gtk.Button('أجبْ')
        self.answer_who.connect('clicked', self.answer_who_cb)
        hb.pack_start(self.answer_who, False, False, 0)
        self.new_who = Gtk.Button('التالي')
        self.new_who.connect('clicked', self.new_who_cb)
        hb.pack_start(self.new_who, False, False, 0)
        vb2.pack_start(hb, False, False, 0)
        
        self.verse_who = d_customs.ViewClass()
        self.verse_who_bfr = self.verse_who.get_buffer()
        self.verse_who.override_font(Pango.FontDescription('Simplified Naskh 22'))
        self.verse_who.set_size_request(-1, 64)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.NEVER)
        scroll.add(self.verse_who)
        vb2.pack_start(scroll, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        self.choice_1 = Gtk.CheckButton('')
        hb.pack_start(self.choice_1, False, False, 0)
        self.choice_1.connect('toggled', self.choice_speaker)
        self.lab_speaker_1 = Gtk.Label()
        hb.pack_start(self.lab_speaker_1, False, False, 0)
        vb2.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        self.choice_2 = Gtk.CheckButton('')
        hb.pack_start(self.choice_2, False, False, 0)
        self.choice_2.connect('toggled', self.choice_speaker)
        self.lab_speaker_2 = Gtk.Label()
        hb.pack_start(self.lab_speaker_2, False, False, 0)
        vb2.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        self.choice_3 = Gtk.CheckButton('')
        hb.pack_start(self.choice_3, False, False, 0)
        self.choice_3.connect('toggled', self.choice_speaker)
        self.lab_speaker_3 = Gtk.Label()
        hb.pack_start(self.lab_speaker_3, False, False, 0)
        vb2.pack_start(hb, False, False, 0)
        
        vb2.pack_start(Gtk.Separator(), False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_1 = Gtk.Label('الإجابات الصحيحة : ')
        lab_1.set_alignment(0, 0.5)
        lab_1.set_size_request(180, -1)
        hb.pack_start(lab_1, False, False, 0)
        self.lab_correct_who = Gtk.Label(0)
        hb.pack_start(self.lab_correct_who, False, False, 0)
        vb2.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_2 = Gtk.Label('المحاولات الفاشلة : ')
        lab_2.set_alignment(0, 0.5)
        lab_2.set_size_request(180, -1)
        hb.pack_start(lab_2, False, False, 0)
        self.lab_false_who = Gtk.Label(0)
        hb.pack_start(self.lab_false_who, False, False, 0)
        vb2.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_3 = Gtk.Label('غير المجاب عنه : ')
        lab_3.set_alignment(0, 0.5)
        lab_3.set_size_request(180, -1)
        hb.pack_start(lab_3, False, False, 0)
        self.lab_skip_who = Gtk.Label(0)
        hb.pack_start(self.lab_skip_who, False, False, 0)
        vb2.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_4 = Gtk.Label('التقييم العام : ')
        lab_4.set_alignment(0, 0.5)
        lab_4.set_size_request(180, -1)
        hb.pack_start(lab_4, False, False, 0)
        self.lab_appraisal_who = Gtk.Label('لا شيء')
        hb.pack_start(self.lab_appraisal_who, False, False, 0)
        vb2.pack_start(hb, False, False, 0)
        self.new_verse_who()
        lab = Gtk.Label('من القائل ؟')
        lab.set_size_request(150, -1)
        self.append_page(vb2, lab)
        
        # a --------------------------------------------
        vb4 = Gtk.Box(spacing=7, orientation=Gtk.Orientation.VERTICAL)
        vb4.set_border_width(7)
        
        hb1 = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        hb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(hb.get_style_context(), "linked")
        self.answer_baher = Gtk.Button('أجبْ')
        self.answer_baher.connect('clicked', self.answer_baher_cb)
        hb.pack_start(self.answer_baher, False, False, 0)
        self.new_baher = Gtk.Button('التالي')
        self.new_baher.connect('clicked', self.new_baher_cb)
        hb.pack_start(self.new_baher, False, False, 0)
        hb1.pack_start(hb, False, False, 0)
        
        lab_0 = Gtk.Label('القائل : ')
        lab_0.set_alignment(0, 0.5)
        self.lab_speaker1 = Gtk.Button()
        self.lab_speaker1.set_relief(Gtk.ReliefStyle.NONE)
        self.lab_speaker1.connect('clicked', self.to_poet)
        hb1.pack_end(self.lab_speaker1, False, False, 0)
        hb1.pack_end(lab_0, False, False, 0)
        vb4.pack_start(hb1, False, False, 0)
        
        self.verse_baher = d_customs.ViewClass()
        self.verse_baher_bfr = self.verse_baher.get_buffer()
        self.verse_baher.override_font(Pango.FontDescription('Simplified Naskh 22'))
        self.verse_baher.set_size_request(-1, 64)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.NEVER)
        scroll.add(self.verse_baher)
        vb4.pack_start(scroll, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        self.choice_baher1 = Gtk.CheckButton('')
        hb.pack_start(self.choice_baher1, False, False, 0)
        self.choice_baher1.connect('toggled', self.choice_baher)
        self.lab_baher_1 = Gtk.Label()
        hb.pack_start(self.lab_baher_1, False, False, 0)
        vb4.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        self.choice_baher2 = Gtk.CheckButton('')
        hb.pack_start(self.choice_baher2, False, False, 0)
        self.choice_baher2.connect('toggled', self.choice_baher)
        self.lab_baher_2 = Gtk.Label()
        hb.pack_start(self.lab_baher_2, False, False, 0)
        vb4.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        self.choice_baher3 = Gtk.CheckButton('')
        hb.pack_start(self.choice_baher3, False, False, 0)
        self.choice_baher3.connect('toggled', self.choice_baher)
        self.lab_baher_3 = Gtk.Label()
        hb.pack_start(self.lab_baher_3, False, False, 0)
        vb4.pack_start(hb, False, False, 0)
        
        vb4.pack_start(Gtk.Separator(), False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_1 = Gtk.Label('الإجابات الصحيحة : ')
        lab_1.set_alignment(0, 0.5)
        lab_1.set_size_request(180, -1)
        hb.pack_start(lab_1, False, False, 0)
        self.lab_correct_baher = Gtk.Label(0)
        hb.pack_start(self.lab_correct_baher, False, False, 0)
        vb4.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_2 = Gtk.Label('المحاولات الفاشلة : ')
        lab_2.set_alignment(0, 0.5)
        lab_2.set_size_request(180, -1)
        hb.pack_start(lab_2, False, False, 0)
        self.lab_false_baher = Gtk.Label(0)
        hb.pack_start(self.lab_false_baher, False, False, 0)
        vb4.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_3 = Gtk.Label('غير المجاب عنه : ')
        lab_3.set_alignment(0, 0.5)
        lab_3.set_size_request(180, -1)
        hb.pack_start(lab_3, False, False, 0)
        self.lab_skip_baher = Gtk.Label(0)
        hb.pack_start(self.lab_skip_baher, False, False, 0)
        vb4.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_4 = Gtk.Label('التقييم العام : ')
        lab_4.set_alignment(0, 0.5)
        lab_4.set_size_request(180, -1)
        hb.pack_start(lab_4, False, False, 0)
        self.lab_appraisal_baher = Gtk.Label('لا شيء')
        hb.pack_start(self.lab_appraisal_baher, False, False, 0)
        vb4.pack_start(hb, False, False, 0)
        self.new_verse_baher()
        lab = Gtk.Label('أيّ بحر ؟')
        lab.set_size_request(150, -1)
        self.append_page(vb4, lab)
        
        # a --------------------------------------------
        vb3 = Gtk.Box(spacing=7, orientation=Gtk.Orientation.VERTICAL)
        vb3.set_border_width(7)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        hb1 = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(hb1.get_style_context(), "linked")
        self.check_verse = Gtk.Button('اعتمدْ')
        self.check_verse.connect('clicked', self.check_verse_cb)
        hb1.pack_start(self.check_verse, False, False, 0)
        self.new_verse = Gtk.Button('التالي')
        self.new_verse.connect('clicked', self.new_verse_cb)
        hb1.pack_start(self.new_verse, False, False, 0)
        self.org_verse = Gtk.Button('نظّم')
        self.org_verse.connect('clicked', self.org_verse_cb)
        hb1.pack_start(self.org_verse, False, False, 0)
        hb.pack_start(hb1, False, False, 0)
        
        info_btn = Gtk.Button(' ؟ ')
        msg = '''
        كلمات كل شطر مبعثرة في نفس الشطر،
        يمكن تحريك الكلمة إلى آخر الشطر بالضغط عليها،
        يمكنك أن تحصل على الترتيب الصحيح 
        بالضغط على الكلمات حسب ذلك الترتيب.
        '''
        info_btn.connect('clicked', lambda *a: d_customs.info(self.parent, msg))
        hb.pack_start(info_btn, False, False, 10)
        
        lab_0 = Gtk.Label('القائل : ')
        lab_0.set_alignment(0, 0.5)
        self.lab_speaker = Gtk.Button()
        self.lab_speaker.set_relief(Gtk.ReliefStyle.NONE)
        self.lab_speaker.connect('clicked', self.to_poet)
        hb.pack_end(self.lab_speaker, False, False, 0)
        hb.pack_end(lab_0, False, False, 0) 
        vb3.pack_start(hb, False, False, 0)
        
        eventbox = Gtk.EventBox()
        eventbox.override_background_color(Gtk.StateFlags.NORMAL, d_customs.rgba(self.parent.theme.colorb))
        eventbox.set_size_request(-1,65) 
        box_verse = Gtk.Box(spacing=11, orientation=Gtk.Orientation.HORIZONTAL)
        self.box_half1 = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        self.box_half2 = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        eventbox.add(box_verse)
        box_verse.pack_start(self.box_half1, False, False, 0)
        box_verse.pack_start(Gtk.Label('***'), False, False, 0)
        box_verse.pack_start(self.box_half2, False, False, 0)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.NEVER)
        scroll.add(eventbox)
        vb3.pack_start(scroll, False, False, 0)
        self.new_verse_organize()
        
        vb3.pack_start(Gtk.Separator(), False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_1 = Gtk.Label('الإجابات الصحيحة : ')
        lab_1.set_alignment(0, 0.5)
        lab_1.set_size_request(180, -1)
        hb.pack_start(lab_1, False, False, 0)
        self.lab_correct = Gtk.Label(0)
        hb.pack_start(self.lab_correct, False, False, 0)
        vb3.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_2 = Gtk.Label('المحاولات الفاشلة : ')
        lab_2.set_alignment(0, 0.5)
        lab_2.set_size_request(180, -1)
        hb.pack_start(lab_2, False, False, 0)
        self.lab_false = Gtk.Label(0)
        hb.pack_start(self.lab_false, False, False, 0)
        vb3.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_3 = Gtk.Label('غير المجاب عنه : ')
        lab_3.set_alignment(0, 0.5)
        lab_3.set_size_request(180, -1)
        hb.pack_start(lab_3, False, False, 0)
        self.lab_skip = Gtk.Label(0)
        hb.pack_start(self.lab_skip, False, False, 0)
        vb3.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        lab_4 = Gtk.Label('التقييم العام : ')
        lab_4.set_alignment(0, 0.5)
        lab_4.set_size_request(180, -1)
        hb.pack_start(lab_4, False, False, 0)
        self.lab_appraisal = Gtk.Label('لا شيء')
        hb.pack_start(self.lab_appraisal, False, False, 0)
        vb3.pack_start(hb, False, False, 0)
        lab = Gtk.Label('رتّب البيت')
        lab.set_size_request(150, -1)
        self.append_page(vb3, lab)
#        self.show_all()  
        