# -*- coding: utf-8 -*-

#a############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
#a############################################################################

from os.path import join
from gi.repository import Gtk, Pango
import d_customs


# class عنوان الصفحة-------------------------------------------------------------------    
    
class TabLabel(Gtk.Box):
    def __init__(self, child, nm):
        self.nm = nm
        self.child=child
        Gtk.Box.__init__(self,orientation=Gtk.Orientation.HORIZONTAL)
        self.close = Gtk.Button()
        img = Gtk.Image.new_from_file(join(d_customs.ICON_DIR, 'tab.png')) 
        self.close.add(img)
        self.close.set_tooltip_text('اغلق هذه الصفحة')
        self.close.set_focus_on_click(True)
        self.close.connect('clicked',self.close_tab)
        self.close.set_relief(Gtk.ReliefStyle.NONE)
        self.lab = Gtk.Label(self.nm)
        self.pack_start(self.lab, True, True,0)
        self.pack_start(self.close, False, False,0)
        self.show_all()

    def close_tab(self, widget):
        notebook = self.get_parent()
        i =  notebook.page_num(self.child)
        if i < 0: return
        w =  notebook.get_nth_page(i)
        try:
            if w.player.is_playing == True:
                res = d_customs.sure(w.parent, 'سوف يتوقف الملف الصوتي عند إغلاقها هل تريد الاستمرار؟')
                if res == Gtk.ResponseType.NO: return
        except: pass
        notebook.remove_page(i)
        try: w.player.stop()
        except: pass
        w.destroy()